---
layout: post
title: Micro on Patreon
date:   2018-04-16 09:00:00
---
<br>
The open source development of micro can now be sponsored via [Patreon](https://www.patreon.com/microhq). Before we 
go into the details, I want to first mention what micro is and it's funding journey.

Micro is an open source project with the mission of simplifying cloud-native development. Technology is rapidly evolving. 
Cloud computing gives us unlimited scale but leveraging that scale with existing tools is still difficult.

Micro is solving this problem with a developer first focus. The project provides an opinionated set of tools that abstract 
away the complexities and details of infrastructure so you can focus on what's really important.

## In The Beginning

The project was created just over 3 years ago. At the end of 2014, after spending time building distributed systems 
tools at Google and Hailo, it was clear there was immense value in their tools but they would never be open sourced.

As with most companies 
these technology stacks were built for the organisation themselves and contained org specific references or assumptions about the 
infrastructure deeply embedded within the code.

To open source that code would have been a measurable effort. As we've now seen, Google and the like have chosen to 
implement new projects from the ground up with the intention of being open source first.

Back in 2014 though, this had yet to happen and I saw the need for a runtime agnostic set of tools focused on abstracting 
away the details of distributed systems with an opinionated interface for developers.

This is what led to the creation of micro.

## Venture Funding

In early 2015 I knew I wanted to pursue micro full time and being at a VC backed company led me to believe the best way 
to do that would be to try raise money from venture capitalists.

I spent a number of months pursuing this effort with little to show for it. The combination of my lack of experience, traction 
and location made it difficult to convince investors this was a venture worth pursuing.

VC funding was not in the cards for micro.

## Self Funding

In mid 2015 micro was an open source project like many others on GitHub, with little traction and no production use. 
It wasn't clear then if it would ever go beyond being just another OSS project on GitHub.


At that point I decided going back to work was the right move. It was however short lived, as a couple months later 
developers started to show interest in using the project at work. This was enough to convince me I needed to focus my efforts 
on micro full time.

From late 2015 onwards, I self funded micro's open source journey, with the hope of finding a more sustainable approach later.

## Enterprise Sponsorship

 A year into it's life, micro attracted the attention of
<a href="https://www.sixt.com/">Sixt</a>, the German car rental enterprise. Sixt undergoing a technical transformation 
understood how micro could be leveraged as a competitive advantage. This led to the first 
<a href="{{ site.baseurl}}/2016/04/25/announcing-sixt-sponsorship.html">Enterprise Sponsorship</a> of micro 
and a potentially better path to funding it's long term open source development.

Since then micro has gone on to be used in production by dozens of companies all over the world. Most building very 
different products yet despite this, they all have one thing in common. 

Micro has become the core technology for building their platforms. 

It's been 2 years since micro was sponsored by Sixt. Our hope was that other enterprises using micro would 
follow suit, enabling us to scale it's development.

We believe there are a number of reasons this has been unsuccessful and came to the realisation that 
the approach to sponsorship for micro needed to change. 

## Joining Patreon


[Patreon](https://www.patreon.com) is a platform for funding creators. There are a number of other similar platforms out there but 
seeing the successful funding of projects like [Vue.js](https://www.patreon.com/evanyou) on Patreon leads me to believe 
this is the best place for micro.

So with that, Micro can now officially be sponsored via <a href="https://www.patreon.com/microhq">Patreon</a>.

<div style="margin: 25px; text-align: center;">
  <a href="https://www.patreon.com/microhq">
    <img src="{{ site.baseurl }}/blog/images/patreon.png" style="height: auto; width: 100%; margin: 0" />
  </a>
</div>

Patreon provides a simple, easy to use and visible place for sponsorship. Micro's users span from individuals 
to multi-billion dollar enterprises. Patreon enables us to specify different levels of sponsorship so that anyone 
can support micro, from as little as $10/month as a backer or $5000/month as an enterprise sponsor.

It's early days but people have already started to show their support with over $500/month in commitment. I would like 
to personally thank them for their support. Join Sixt and the many others by sponsoring Micro on [Patreon](https://www.patreon.com/microhq).

## The Future

I'm excited by all the possibilities enabled by opening up sponsorship to everyone via [Patreon](https://www.patreon.com/microhq) 
but also thinking more and more about the long term future of micro.

Open source sustainability is a hot topic of discussion. It's something I'm living and breathing on a daily basis. 
I believe sponsorship is a strong route forward but projects must also look beyond it to be truly sustainable.

Micro today is an open source project funded by sponsorship. In the future we may look toward an open core model. 
Providing a turn-key enterprise solution.

This would enable a self-sustaining future for micro while allowing it to fund it's own open source development. 
Reach out to discuss or learn more.

<center><p>...</p></center>
If you want to learn more about micro, checkout the [website](https://m3o.com) or 
visit [GitHub](https://github.com/micro/micro).

Follow us on [Twitter](https://twitter.com/m3ocloud) or join the [Slack](http://slack.m3o.com) community.


